/*-
 * Copyright (C) 2002 Juergen Keil.
 * Copyright (C) 2002 TooLs GmbH.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by TooLs GmbH.
 * 4. The name of TooLs GmbH may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY TOOLS GMBH ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL TOOLS GMBH BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#include "audio_codec.h"

struct akm4531_codec_ops {
    int (*akm4531_write)(void *, uint8_t sub_addr, uint8_t value);
    int (*akm4531_wait_idle)(void *);
};

#define	AKM4531_WRITE(acm, addr, data)					\
	((acm)->akm4531_ops->akm4531_write((acm)->akm4531_data, (addr), (data)))
#define	AKM4531_WAIT_IDLE(acm)						\
	((acm)->akm4531_ops->akm4531_wait_idle((acm)->akm4531_data))

struct akm4531_codec {
    struct audio_codec	base;

    audiohdl_t		audio_handle;
    struct akm4531_codec_ops *akm4531_ops;
    void	       *akm4531_data;

    uint8_t		akm4531_mic_30db_boost;
    uint8_t		akm4531_pcmvol;

    audio_info_t        audio_info;     /* driver local audio state. Note: */
                                        /* we maintain only a few fields */
                                        /* of the structure in the driver */
};

extern audio_codec_handle_t akm4531_codec_init(audiohdl_t, struct akm4531_codec_ops *, void *);
